/////////////////////////////////////////////////////////////////////////
//
// CFGBASE.HPP - Declaration of AConfigBase, the configuration base class
//
// (c) 1997 by Stefan Ruck, Frankfurt/Main, Germany
//
/////////////////////////////////////////////////////////////////////////

#ifndef _CFGBASE_HPP_
#define _CFGBASE_HPP_

#pragma info (none)

#define INCL_DOSMODULEMGR
#define INCL_DOSPROCESS
#define INCL_DOSMISC
#define INCL_ERRORS
#include <os2.h>
 
#include <IBase.hpp>
#include <istring.hpp>

#pragma info (restore)

#include "afile.hpp"

class AConfigBase : public IBase

{
  public:
    AConfigBase (const char * pszSuffix);

    virtual ~AConfigBase () = 0;

    const IString& getFullFilename () { return (m_strFullFilename); }
    const IString& getPureFilename () { return (m_strPureFilename); }
    const IString& getPathname ()     { return (m_strPathname); }

  private:
    AConfigBase& filenameFromAppDir (const char * pszSuffix);     // build filename from app directory
                 // throws IAccessError

    APIRET filenameFromIniDir ();     // build filename from ini directory

    APIRET filenameFromCurrDir ();    // build filename from current directory

    AConfigBase& filenameFromSystemDir ();  // build filename from system directory
                 // throws IAccessError

    AConfigBase& buildPathname ();    // build the pathname from m_strFullFilename

    Boolean tryOpenFile (AFile& rFile, IString& rstrFile);
            // throws IAccessError

    IString m_strFullFilename,   // filename including path
            m_strPureFilename,   // filename without path, but with leading '\'
            m_strPathname;       // only the path

    APIRET m_ret;                // keeps the return value of the API calls
};

#endif // _CFGBASE_HPP_
