//////////////////////////////////////////////////////////////////////////////////
//
// CFGFILE.HPP - Declaration of AConfigFile, the configuration file template class
//
// (c) 1997 by Stefan Ruck, Frankfurt/Main, Germany
//
///////////////////////////////////////////////////////////////////////////////////

#ifndef _CFGFILE_H_
#define _CFGFILE_H_

#define INCL_DOSMODULEMGR
#define INCL_DOSPROCESS
#define INCL_DOSMISC
#define INCL_ERRORS
#include <os2.h>
 
#include <istring.hpp>

#include "cfgbase.hpp"
#include "afile.hpp"

template <class T> class AConfigFile : public AConfigBase,
                                       public AFile

{
  public:
    AConfigFile ();
    virtual ~AConfigFile () = 0;

    T * getConfigData () { return (&m_ConfigData); }

    APIRET open (const ULONG ulFileAttribute = FILE_NORMAL,
                 const ULONG ulOpenFlag = FILE_OPEN | FILE_CREATE,
                 const ULONG ulOpenMode = OPEN_ACCESS_READWRITE | OPEN_SHARE_DENYREADWRITE,
                 const PEAOP2 pEABuf = 0L)
                 {
                  return (AFile :: open (getFullFilename (), sizeof (T), ulFileAttribute, ulOpenFlag, ulOpenMode, pEABuf));  // open the ini file
                 }

    APIRET read (const ULONG ulFileAttribute = FILE_NORMAL,
                 const ULONG ulOpenFlag = FILE_OPEN,
                 const ULONG ulOpenMode = OPEN_ACCESS_READONLY | OPEN_SHARE_DENYWRITE,
                 const PEAOP2 pEABuf = 0L);

    APIRET write (const ULONG ulFileAttribute = FILE_NORMAL,
                  const ULONG ulOpenFlag = FILE_OPEN | FILE_CREATE,
                  const ULONG ulOpenMode = OPEN_ACCESS_WRITEONLY | OPEN_SHARE_DENYREADWRITE,
                  const PEAOP2 pEABuf = 0L);

  private:
    T m_ConfigData;
};

#endif // _CFGFILE_H_
