/////////////////////////////////////////////////////////////////////////
//
// INICFG.CPP - Definition of AIniConfig, initialization using AIniFile
//
// (c) 1997 by Stefan Ruck, Frankfurt/Main, Germany
//
/////////////////////////////////////////////////////////////////////////

#include "inicfg.hpp"

#pragma info (none)
#include <istring.hpp>
#pragma info (restore)

const char * const AIniConfig :: m_pszPosition = "Position";  // define the string for the position key

//**********************************************************************************
// AIniConfig :: getPosition - return the value saved for the position             *
//**********************************************************************************

POINTL AIniConfig :: getPosition () const

{
  POINTL pointRet = { 0, 0 };                     // initialize the return value;

  if(!isPositionSaved ())                         // was an element saved for the position?
     return (pointRet);                           // no, return

  // an element for the position exists, so retrieve it

  IString strPosition (elementWithKey (m_pszPosition));

  memcpy (&pointRet, (char *) strPosition, sizeof (POINTL));  // convert IString to POINTL

  return (pointRet);
}

//***************************************************************************
// AIniConfig :: setPosition - set the element for the position             *
//***************************************************************************

AIniConfig& AIniConfig :: setPosition (const POINTL pPosition)

{
  IString strPosition (&pPosition, sizeof (POINTL), 0x0);

  addOrReplaceElementWithKey (m_pszPosition, strPosition);

  return (*this);
}
