//////////////////////////////////////////////////////////////////////////////////
//
// INIFILE.CPP - Definition of AIniFile, the programming guideline conforming
//               initialization class
//
// (c) 1997 by Stefan Ruck, Frankfurt/Main, Germany
//
///////////////////////////////////////////////////////////////////////////////////

#include "inifile.hpp"

#pragma info (none)

#include <istring.hpp>

#pragma info (restore)

//**************************************************************
// AIniFile :: AIniFile - Constructor of AIniFile              *
//**************************************************************

AIniFile :: AIniFile ()
            : AConfigBase ("INI"),
              IProfile (getFullFilename ())

{
  IString strApplicationName (getPureFilename ());

  strApplicationName. remove (0, 1);                                  // remove the leading '\'

  strApplicationName. remove (strApplicationName. lastIndexOf ('.')); // remove the suffix '.ini'

  setDefaultApplicationName (strApplicationName);                     // set the default application name
}

//**************************************************************
// AIniFile :: ~AIniFile - Destructor of AIniFile              *
//**************************************************************

AIniFile :: ~AIniFile ()

{
}
