///////////////////////////////////////////////////////////////////////////////////////////
//
// INITEST.HPP - Declaration of AIniFileTest, the configuration file sample application
//
// (c) 1997 by Stefan Ruck, Frankfurt/Main, Germany
//
///////////////////////////////////////////////////////////////////////////////////////////

#ifndef _INITEST_HPP_
#define _INITEST_HPP_

#pragma info (none)

#include <iframe.hpp>
#include <imenubar.hpp>
#include <icmdhdr.hpp>

#pragma info (restore)

#include "cfgcfg.hpp"
#include "inicfg.hpp"

class AIniFileTest : public IFrameWindow,
                     public ICommandHandler

{
  public:                               
    AIniFileTest (unsigned long windowId);          // Constructor
    ~AIniFileTest (void);                           // Destructor for this class

  protected:
    void cleanUp (void);                            // clean up of the allocated resources
    Boolean setupVariables (void);                  // set up the variables
    Boolean command(ICommandEvent &evt);            // command handling

  private:
    IMenuBar * m_pMenuBar;                          // pointer to the menu bar
    ACfgConfig * m_pCfgConfig;                      // pointer to the configuration file
    AIniConfig * m_pIniConfig;                      // pointer to the initialization file

    // default exception handler class
    class ExceptionHandler : public IWindow::ExceptionFn
        {
         public:
           virtual Boolean handleException(IException &exception, 
                                           IEvent     &event);
        };

    ExceptionHandler excHandler;
};


#endif //_INITEST_HPP_
